/*  load.c

   5 December 2001
   modify from s1 sim 1997, 1998

   add print, printc  to output buffer  31 Dec 2001
   modify to read mspec					14 Feb 2005
   for Sx cpu simulator					11 July 2006
*/

#include "sx.h"

#define 	PRIVATE		static

int CP, DP;		// end of CS, end of loaded DS

void error(char *s){
	printf("error: %s\n",s);
	exit(0);
}

PRIVATE void report(void){
  float cpi;
  if( ninst == 0 )
	  printf("0 instruction\n");
  else {
  	  cpi = ((float) clock)/ninst;
  	  printf("%d instructions, %d clocks, CPI %4.2f\n",
	  	ninst,clock,cpi);
  }
}

// static alloc memory of size a
PRIVATE int xalloc(int a){
	int b;
	b = DP;
	if( DP + a >= MAXDS )
		error("xalloc: out of memory");
	DP += a;
	return b;
}

PRIVATE void popts(void){
	TS = M[SP];
	SP--;
}

void trap(int op, int arg){		/* special function */
	int n;
	switch(op) {
	case icEnd :
		report();
		runflag = 0;
		break;
	case icArray:
		TS = xalloc(TS);
		break;
	case icSys:
		switch(arg){
		case 1: 		// print ts
  	  		printf("<%d>", TS);
			popts();
	  		break;
		case 2 : 		// printc ts
			printf("%c", TS);
			popts();
	  		break;
		case 13:
			runflag = 0;
			break;
		default:
			error("unknown syscall");
		}
		break;
	default:
		error("unknown trap");
	}
}


PRIVATE int readM(int *mem, FILE *fi){
	int i, b, e, c;
	fscanf(fi,"%d%d",&b,&e);
	for(i=b; i<=e; i++){
		fscanf(fi,"%d",&c);
		mem[i] = c;
	}
	return e;
}

// read obj from stdin into memory
void loadobj(char *fn){
	int a;
	FILE *fi;
	fi = fopen(fn,"r");
	if(fi == NULL){
	 printf("input file not found");
	 exit(0);
	}
	fscanf(fi,"%d",&a);
	if( a != OBJ_SOMv2 )
		error("not a som-v2 object");
	a = readM(M,fi);	// code
	CP = a + 1;
	a = readM(M,fi);	 	// string constant, data
	DP = a + 1;
	fclose(fi);
	printf("load program, last address %d\n",CP);
	printf("DP %d\n",DP);
}
